{% extends '@KaitekFramework/Backend/module.html.twig' %}
{% trans_default_domain (modulename) %}
{% block begin_javascript_fix %}
<script type="text/javascript">
    {% endblock begin_javascript_fix %}

    {% block begin_javascript %}
    {{ parent() }}
    {{ modulename }}Obj.prototype = {
        storeConfig:{
            //ClientG:{routeName:'BaseController-getComboValues',table:'clients'}
            //,JobRotationG:{routeName:'JobRotation-getComboValues',table:'job_rotations'}
            //,Employee:{routeName:'Employee-getComboValues',table:'employees',modulename:'Employee',fieldId:'code',fieldDisplay:'name',options:{isquality:true}}
            //,QualityRejectionType:{routeName:'BaseController-getComboValues',table:'quality_rejection_types'}
        },
        _onButtonClick:function(a){
            var _msg='';
            if(a.alt=='Onay'){
                _msg="{{ 'RemoteQualityConfirmation.qualityconfirm'|trans }}";
            }else{
                _msg="{{ 'RemoteQualityConfirmation.qualityrejection'|trans }}";
            }
            var t = this;
            var selectedRecord = t.getSelectedRecord();
            if (selectedRecord !== false) {
                if(t._Timer){
                    clearTimeout(t._Timer);
                }
                mj.message({
                    title: mj.lng.glb.winTitleOnay,
                    modal : true,
                    msg: _msg,
                    buttons:['NO','YES'],
                    cb:function(el,btn){
                        if(btn=='YES'){
                            if(t.winchild){
                                t.winchild.destroy();
                                t.forms.child.destroy();
                            }
                            t.winchild = new mj.window({
                                renderTo : mj.NE(),
                                title : a.alt,
                                modal : false,
                                width : 400,
                                height : 200,
                                minWidth : 400,
                                minHeight : 200,
                                buttons : [
                                    {alt: mj.lng.glb.exit,iconCls: 'mj-menu-exit-icon', handler:function(){
                                        t._Timer = setTimeout(function(){t.grids.main.load();},t.refreshInterval*1000);
                                        t.winchild.hide();
                                    }},
                                    {alt: mj.lng.glb.save,iconCls: 'mj-save', handler:function(){
                                        var data =  t.forms.child.getValue();
                                        if(data.employee==null||data.employee==''){
                                            t.messageShow(t,mj.lng.glb.error,"{{ 'RemoteQualityConfirmation.errnotfoundemployee'|trans }}");
                                            return;
                                        }
                                        if((data.description==null||data.description=='')&&a.alt=='Red'&&(data.qualityrejectiontype==null||data.qualityrejectiontype=='')){
                                            t.messageShow(t,mj.lng.glb.error,"{{ 'RemoteQualityConfirmation.errnotfounddescription'|trans }}");
                                            return;
                                        }
                                        var id = selectedRecord.id;
                                        var version = selectedRecord.version;
                                        var routeName = t.modulename + '-update';
                                        var route = Routing.getRoute(routeName);
                                        var pagerParams = (t.grids && t.grids.main && t.grids.main.pbar) ? {
                                            'pg': t.grids.main.pbar.current,
                                            'lm': t.grids.main.pbar.limit
                                        } : {};
                                        var url = Routing.generate(routeName, id ? mj.apply(pagerParams, {
                                            'id': id,
                                            'v': version
                                        }) : pagerParams);
                                        if (route && route.methods && route.methods.length>0 && route.methods[0]) {
                                            t.waitMaskShow();
                                            data.menuId=t.id;
                                            data.client=selectedRecord.client;
                                            data.type=a.alt;
                                            $.ajax({
                                                url: url,
                                                method: "POST",
                                                headers: { 
                                                    "Content-Type": "application/json",
                                                    "X-HTTP-Method-Override": route.methods[0] 
                                                },
                                                dataType: 'json',
                                                data: JSON.stringify(data),
                                                success: function(data, textStatus, jqXHR) {
                                                    //t.stores.main.load();
                                                    t.waitMaskHide();
                                                    var g=t.grids.main;
                                                    var idx=g.store.data.getIndex('id',selectedRecord.id);
                                                    g.store.data.splice(idx,1);
                                                    g._onLoad();
                                                    if (t.buttons.confirm) {
                                                        t.buttons.confirm.setDisable();
                                                    }
                                                    if (t.buttons.rejection) {
                                                        t.buttons.rejection.setDisable();
                                                    }
                                                    t._Timer = setTimeout(function(){t.grids.main.load();},10000);
                                                },
                                                error: function(jqXHR, textStatus, errorThrown) {
                                                    t.waitMaskHide();
                                                    mj.message({
                                                        title: mj.lng.glb.error,
                                                        msg: jqXHR.responseJSON.message + "<br>" + jqXHR.responseJSON.file,
                                                        type: "error",
                                                        html: true
                                                    });
                                                    t._Timer = setTimeout(function(){t.grids.main.load();},t.refreshInterval*1000);
                                                },
                                                complete: function(jqXHR, textStatus) {
                                                    //t.waitMaskHide();
                                                }
                                            });
                                        }
                                        t.winchild.hide();
                                    }}
                                ]
                            });
                            t.win.addRelated(t.winchild);
                            var _items=(a.alt=='Onay'?[
                                    new mj.form.combo({
                                        title: "{{ 'RemoteQualityConfirmation.employee'|trans }}",
                                        placeHolder: "{{ 'RemoteQualityConfirmation.employee_placeholder'|trans }}",
                                        dataIndex: 'employee',
                                        mode: 'local',
                                        clearOnTriggerClick: true,
                                        labelWidth : '90px',
                                        grid: 's6 m4',
                                        width:250,
                                        sameValueDisplay:false,
                                        store: t.extras.employees
                                    }),
                                    new mj.form.textArea({
                                        title: "{{ 'RemoteQualityConfirmation.description'|trans }}",
                                        dataIndex: 'description',
                                        maxLength: 250,
                                        labelWidth : '90px',
                                        width:250,
                                        height:80,
                                        grid: 's4 m2'
                                    })
                                ]:[
                                    new mj.form.combo({
                                        title: "{{ 'RemoteQualityConfirmation.employee'|trans }}",
                                        placeHolder: "{{ 'RemoteQualityConfirmation.employee_placeholder'|trans }}",
                                        dataIndex: 'employee',
                                        mode: 'local',
                                        clearOnTriggerClick: true,
                                        labelWidth : '90px',
                                        grid: 's6 m4',
                                        width:250,
                                        sameValueDisplay:false,
                                        store: t.extras.employees
                                    }),
                                    new mj.form.combo({
                                        title: "{{ 'RemoteQualityConfirmation.qualityrejectiontype'|trans }}",
                                        placeHolder: "{{ 'RemoteQualityConfirmation.qualityrejectiontype_placeholder'|trans }}",
                                        dataIndex: 'qualityrejectiontype',
                                        mode: 'local',
                                        clearOnTriggerClick: true,
                                        labelWidth : '90px',
                                        grid: 's6 m4',
                                        width:250,
                                        sameValueDisplay:false,
                                        store: t.extras.quality_rejection_types
                                    }),
                                    new mj.form.textArea({
                                        title: "{{ 'RemoteQualityConfirmation.description'|trans }}",
                                        dataIndex: 'description',
                                        maxLength: 250,
                                        labelWidth : '90px',
                                        width:250,
                                        height:60,
                                        grid: 's4 m2'
                                    })
                                ]);
                            t.forms.child = new mj.form({
                                renderTo : t.winchild.getBody(),
                                store : new mj.store({}),
                                buttonPos:false,
                                items: _items
                            });
                            t.winchild.show();
                        }else{
                            t._Timer = setTimeout(function(){t.grids.main.load();},t.refreshInterval*1000);
                        }
                        el.window.close();
                    }
                });
            }
        },
        init : function(){
            var t = this;
            t.refreshInterval = 30;
            {{ modulename }}Obj.superclass.init.call(t);
            t.recordsperpage=10000;
            t.windowButtons.add=false;
            t.windowButtons.edit=false;
            t.windowButtons.delete=false;
            var routeName = t.modulename + '-showall';
            var route = Routing.getRoute(routeName);
			var data = {
				'pg': 1,
				'lm': t.recordsperpage
			};
			var url = Routing.generate(routeName, data);
            t.stores.main.url=url;
            const gridConfig = {
                pbar: new mj.pager({
                    pos: 'bottom',
                    beforePageText: false,
                    limit: t.recordsperpage,
                    defaultButtons:false,
                    elements:{
                        selectLimit:false,
                        refresh : true
                    }
                }),
                cm: [
                    {header: "{{ 'RemoteQualityConfirmation.client'|trans }}", dataIndex: 'client',width: 100,filter:'single',alias:'cld',type:'combo',store:t.extras.clients,operator:'='},
                    {header: "{{ 'RemoteQualityConfirmation.day'|trans }}", dataIndex: 'day', width: 70,filter:'between',alias:'cld'},
                    {header: "{{ 'RemoteQualityConfirmation.jobrotation'|trans }}", dataIndex: 'jobrotation', width: 80,filter:'single',type:'combo',store:t.extras.job_rotations,alias:'cld',operator:'='},
                    {header: "{{ 'RemoteQualityConfirmation.opname'|trans }}", dataIndex: 'opname', width: 500,filter:'single',alias:'cld',operator:'%.%'},
                    {header: "{{ 'RemoteQualityConfirmation.erprefnumber'|trans }}", dataIndex: 'erprefnumber', width: 100,filter:'single',alias:'cld',operator:'%.%'},
                    {header: "{{ 'RemoteQualityConfirmation.start'|trans }}", dataIndex: 'start', width: 120,alias:'cld',filter:'between'},
                    {header: "{{ 'RemoteQualityConfirmation.duration'|trans }}", dataIndex: 'duration', width: 120,alias:'cld'}
                ]
            };

            t._setGridConfig(gridConfig);

            const formConfig= {
                items: [
                    new mj.form.field({
                        dataIndex: 'id',
                        hidden: true
                    }),
                    new mj.form.field({
                        dataIndex: 'version',
                        hidden: true
                    })
                ]
            };
            t._setFormConfig(formConfig);
            t._Timer = false;
            t.grids.main.store.on("load",function(){
                if(t._Timer)
                    clearTimeout(t._Timer);
                t._Timer = setTimeout(function(){t.grids.main.load();},t.refreshInterval*1000);
            });
                
            t.win.on('beforeclose', function(){clearTimeout(t._Timer);});
            if(typeof t.grids.main.pbar.tbar.addSplitter==='function'){
				t.grids.main.pbar.tbar.addSplitter();
			}
            t.buttons.confirm = t.grids.main.pbar.tbar.addButton({
                alt: "{{ 'RemoteQualityConfirmation.confirm'|trans }}",
                cls: 'btn-sm left',
                iconCls: 'mj-accept',
                scope: t,
                handler: t._onButtonClick
			});
            t.buttons.rejection = t.grids.main.pbar.tbar.addButton({
                alt: "{{ 'RemoteQualityConfirmation.rejection'|trans }}",
                cls: 'btn-sm left',
                iconCls: 'mj-delete',
                scope: t,
                handler: t._onButtonClick
			});
            t.buttons.confirm.setDisable();
            t.buttons.rejection.setDisable();
            t.grids.main.on('rowclick', function(){
                var t = this;
                if (t.buttons.confirm) {
                    t.buttons.confirm.setEnable();
                }
                if (t.buttons.rejection) {
                    t.buttons.rejection.setEnable();
                }
            }, t);
            t.stores.main.on('load', function(){
                var t = this;
                if (t.buttons.confirm) {
                    t.buttons.confirm.setDisable();
                }
                if (t.buttons.rejection) {
                    t.buttons.rejection.setDisable();
                }
            },t);
        }
        ,editSelectedRecord: function() {
            return;
        }
    };
    {% endblock begin_javascript %}



    {% block begin_default_module %}
    {{ parent() }}
    {% endblock begin_default_module %}



    {% block end_default_module %}
    {{ parent() }}
    {% endblock end_default_module %}


    {% block end_javascript %}
    {{ parent() }}
    {% endblock end_javascript %}


    {% block end_javascript_fix %}
</script>
{% endblock end_javascript_fix %}



{% block body %}
    {{ parent() }}
{% endblock body %}
